﻿package dao

import "code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"

type SuperCloudIssuanceKeywordReplyWithActivateGroupDao interface {
	GetSuperCloudIssuanceKeywordReplyWithActivateGroup(activateGroupId int) (m *models.SuperCloudIssuanceKeywordReplyWithActivateGroup, err error)
	FindSuperCloudIssuanceKeywordReplyWithActivateGroup(uid, page, pageSize int) (m []*FindSuperCloudIssuanceKeywordReplyWithActivateGroupResponse, total int64, err error)
	InsertSuperCloudIssuanceKeywordReplyWithActivateGroup(m *models.SuperCloudIssuanceKeywordReplyWithActivateGroup) (id int, err error)
	SaveSuperCloudIssuanceKeywordReplyWithActivateGroup(id interface{}, m *models.SuperCloudIssuanceKeywordReplyWithActivateGroup, forceColums ...string) (affected int64, err error)
}

type FindSuperCloudIssuanceKeywordReplyWithActivateGroupResponse struct {
	Id               int    `json:"id" xorm:"not null pk autoincr comment('自增id') INT(11)"`
	ActivateGroupId  int    `json:"activate_group_id" xorm:"not null default 0 comment('绑定激活群id') INT(11)"`
	State            int    `json:"state" xorm:"not null default 1 comment('状态(1正常 2暂停)') TINYINT(1)"`
	IsFollowOfficial int    `json:"is_follow_official"`
	CreateAt         string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt         string `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	Uid              int    `json:"uid"`
	Name             string `json:"name"`
	RobotId          int    `json:"robot_id"`
	ChatRoomId       string `json:"chat_room_id"`
	ChatRoomOwner    string `json:"chat_room_owner"`
	MemberCount      int    `json:"member_count"`
	BigHeadImgUrl    string `json:"big_head_img_url"`
	SmallHeadImgUrl  string `json:"small_head_img_url"`
}
