﻿package implement

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/dao"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_model.git/utils/logx"
	"xorm.io/xorm"
)

func NewSuperCloudIssuanceKeywordReplyWithActivateGroupDb(engine *xorm.Engine) dao.SuperCloudIssuanceKeywordReplyWithActivateGroupDao {
	return &SuperCloudIssuanceKeywordReplyWithActivateGroupDb{Db: engine}
}

type SuperCloudIssuanceKeywordReplyWithActivateGroupDb struct {
	Db *xorm.Engine
}

func (s SuperCloudIssuanceKeywordReplyWithActivateGroupDb) GetSuperCloudIssuanceKeywordReplyWithActivateGroup(activateGroupId int) (m *models.SuperCloudIssuanceKeywordReplyWithActivateGroup, err error) {
	m = new(models.SuperCloudIssuanceKeywordReplyWithActivateGroup)
	has, err := s.Db.Where("activate_group_id =?", activateGroupId).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (s SuperCloudIssuanceKeywordReplyWithActivateGroupDb) FindSuperCloudIssuanceKeywordReplyWithActivateGroup(uid, page, pageSize int) (resp []*dao.FindSuperCloudIssuanceKeywordReplyWithActivateGroupResponse, total int64, err error) {
	total, err = s.Db.Table("super_cloud_issuance_user_robot_with_activate_group").
		Join("LEFT", "super_cloud_issuance_keyword_reply_with_activate_group", "super_cloud_issuance_user_robot_with_activate_group.id = super_cloud_issuance_keyword_reply_with_activate_group.activate_group_id").
		Where("super_cloud_issuance_user_robot_with_activate_group.uid = ?", uid).
		OrderBy("super_cloud_issuance_user_robot_with_activate_group.id DESC").
		Cols("super_cloud_issuance_keyword_reply_with_activate_group.*,"+
			" super_cloud_issuance_user_robot_with_activate_group.uid,"+
			" super_cloud_issuance_user_robot_with_activate_group.name,"+
			" super_cloud_issuance_user_robot_with_activate_group.robot_id,"+
			" super_cloud_issuance_user_robot_with_activate_group.chat_room_id,"+
			" super_cloud_issuance_user_robot_with_activate_group.member_count,"+
			" super_cloud_issuance_user_robot_with_activate_group.big_head_img_url,"+
			" super_cloud_issuance_user_robot_with_activate_group.small_head_img_url,"+
			" super_cloud_issuance_user_robot_with_activate_group.chat_room_owner").
		Limit(pageSize, (page-1)*pageSize).
		FindAndCount(&resp)
	return
}

func (s SuperCloudIssuanceKeywordReplyWithActivateGroupDb) InsertSuperCloudIssuanceKeywordReplyWithActivateGroup(m *models.SuperCloudIssuanceKeywordReplyWithActivateGroup) (id int, err error) {
	_, err = s.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	id = m.Id
	return id, nil
}

func (s SuperCloudIssuanceKeywordReplyWithActivateGroupDb) SaveSuperCloudIssuanceKeywordReplyWithActivateGroup(id interface{}, m *models.SuperCloudIssuanceKeywordReplyWithActivateGroup, forceColums ...string) (affected int64, err error) {
	if forceColums != nil {
		affected, err = s.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = s.Db.Where("id=?", id).Update(m)
	}
	return
}
