﻿package implement

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/dao"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	"reflect"
	"xorm.io/xorm"
)

func NewSuperCloudIssuanceUserGroupManageBlackListDb(engine *xorm.Engine) dao.SuperCloudIssuanceUserGroupManageBlackListDao {
	return &SuperCloudIssuanceUserGroupManageBlackListDb{Db: engine}
}

type SuperCloudIssuanceUserGroupManageBlackListDb struct {
	Db *xorm.Engine
}

func (s SuperCloudIssuanceUserGroupManageBlackListDb) SuperCloudIssuanceUserGroupManageBlackListDelete(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return s.Db.In("id", id).Delete(models.SuperCloudIssuanceUserGroupManageBlackList{})
	} else {
		return s.Db.Where("id = ?", id).Delete(models.SuperCloudIssuanceUserGroupManageBlackList{})
	}
}

func (s SuperCloudIssuanceUserGroupManageBlackListDb) BatchSuperCloudIssuanceUserGroupManageBlackList(list []*models.SuperCloudIssuanceUserGroupManageBlackList) (int64, error) {
	affected, err := s.Db.Insert(list)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (s SuperCloudIssuanceUserGroupManageBlackListDb) SaveSuperCloudIssuanceUserGroupManageBlackList(id interface{}, m *models.SuperCloudIssuanceUserGroupManageBlackList, forceColums ...string) (affected int64, err error) {
	if forceColums != nil {
		affected, err = s.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = s.Db.Where("id=?", id).Update(m)
	}
	return
}

func (s SuperCloudIssuanceUserGroupManageBlackListDb) FindAndCountSuperCloudIssuanceUserGroupManageBlackList(uid int) (m []*models.SuperCloudIssuanceUserGroupManageBlackList, total int64, err error) {
	total, err = s.Db.Where("uid=?", uid).OrderBy("id DESC").FindAndCount(&m)
	return
}

func (s SuperCloudIssuanceUserGroupManageBlackListDb) FindSuperCloudIssuanceUserGroupManageBlackList(uid int, name string) (resp []*dao.FindSuperCloudIssuanceUserGroupManageBlackListResponse, err error) {
	if name == "" {
		err = s.Db.Table("super_cloud_issuance_user_robot_with_activate_group").
			Join("LEFT", "super_cloud_issuance_user_group_manage_black_list", "super_cloud_issuance_user_robot_with_activate_group.id = super_cloud_issuance_user_group_manage_black_list.activate_group_id").
			Where("super_cloud_issuance_user_robot_with_activate_group.uid = ?", uid).
			OrderBy("super_cloud_issuance_user_robot_with_activate_group.id DESC").
			Cols("super_cloud_issuance_user_group_manage_black_list.id, super_cloud_issuance_user_group_manage_black_list.uid," +
				"super_cloud_issuance_user_group_manage_black_list.create_at, super_cloud_issuance_user_group_manage_black_list.update_at," +
				"super_cloud_issuance_user_robot_with_activate_group.name, super_cloud_issuance_user_robot_with_activate_group.robot_id," +
				"super_cloud_issuance_user_robot_with_activate_group.chat_room_id, super_cloud_issuance_user_robot_with_activate_group.chat_room_owner_wx_nickname," +
				"super_cloud_issuance_user_robot_with_activate_group.chat_room_owner_wx_head_url, super_cloud_issuance_user_robot_with_activate_group.chat_room_owner," +
				"super_cloud_issuance_user_robot_with_activate_group.member_count, super_cloud_issuance_user_robot_with_activate_group.big_head_img_url, super_cloud_issuance_user_robot_with_activate_group.small_head_img_url").
			Find(&resp)
	} else {
		err = s.Db.Table("super_cloud_issuance_user_robot_with_activate_group").
			Join("LEFT", "super_cloud_issuance_user_group_manage_black_list", "super_cloud_issuance_user_robot_with_activate_group.id = super_cloud_issuance_user_group_manage_black_list.activate_group_id").
			Where("super_cloud_issuance_user_robot_with_activate_group.uid = ?", uid).
			And("super_cloud_issuance_user_robot_with_activate_group.name like ?", name).
			OrderBy("super_cloud_issuance_user_robot_with_activate_group.id DESC").
			Cols("super_cloud_issuance_user_group_manage_black_list.id, super_cloud_issuance_user_group_manage_black_list.uid," +
				"super_cloud_issuance_user_group_manage_black_list.create_at, super_cloud_issuance_user_group_manage_black_list.update_at," +
				"super_cloud_issuance_user_robot_with_activate_group.name, super_cloud_issuance_user_robot_with_activate_group.robot_id," +
				"super_cloud_issuance_user_robot_with_activate_group.chat_room_id, super_cloud_issuance_user_robot_with_activate_group.chat_room_owner_wx_nickname," +
				"super_cloud_issuance_user_robot_with_activate_group.chat_room_owner_wx_head_url, super_cloud_issuance_user_robot_with_activate_group.chat_room_owner," +
				"super_cloud_issuance_user_robot_with_activate_group.member_count, super_cloud_issuance_user_robot_with_activate_group.big_head_img_url, super_cloud_issuance_user_robot_with_activate_group.small_head_img_url").
			Find(&resp)
	}
	return
}
